#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "general.h"

/*

Nokia Icon - Copyright 2001 Michael Kohn (mike@naken.cc)
This falls under the Kohnian license.  Please read
it at http://nakentone.naken.cc/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int main (int argc, char *argv[])
{
FILE *fp;
char filename[1024];
int width,height;
int x,y;
int ch,lastch,t,k,r;
int full_sms_size;
int mcc,mnc;
int headers;

  width=72;
  height=14;
  stackptr=0;
  bitptr=7;
  full_sms_size=SMS_SIZE;
  mcc=-1; mnc=-1;
  headers=1;

  if (argc<2)
  {
    printf("\nnokia_icon "VERSION" - Nokia Phone icon maker.\n");
    printf(COPYRIGHT);
    printf("width, height are optional (default 72x14)\n");
    printf("Usage: nokia_icon [ options ] <input filename>\n");
    printf("       -s <sms size> [ Maximum size of SMS message (default %d)\n",SMS_SIZE);
    printf("       -x [ exclude //SCKL header ]\n");
    printf("       -u [ only user-data-header (8bit) ]\n");
    printf("       -k [ include user-data-header and //SCKL ]\n");
    printf("       -w <width> [ Width of Logo (default %d) ]\n",width);
    printf("       -h <height> [ Height of Logo (default %d) ]\n",height);
    printf("       -l <MCC> <MNC> [ Operator Logo (requires MCC and MNC) ]\n\n");
    exit(0);
  }

  printf("\nnokia_icon "VERSION" - Nokia Phone icon maker.\n");
  printf(COPYRIGHT);

  for (t=1; t<argc; t++)
  {
    if (strcmp(argv[t],"-s")==0)
    { full_sms_size=atoi(argv[++t]); }
      else
    if (strcmp(argv[t],"-w")==0)
    { width=atoi(argv[++t]); }
      else
    if (strcmp(argv[t],"-x")==0)
    { headers=0; }
      else
    if (strcmp(argv[t],"-k")==0)
    { headers=2; }
      else
    if (strcmp(argv[t],"-u")==0)
    { headers=3; }
      else
    if (strcmp(argv[t],"-h")==0)
    { height=atoi(argv[++t]); }
      else
    if (strcmp(argv[t],"-l")==0)
    { 
      mcc=atoi(argv[++t]);
      mnc=atoi(argv[++t]);
    }
      else
    { strncpy(filename,argv[t],1023); }
  }

  printf("\nInput Filename: %s\n",filename);
  printf("         Width: %d\n",width);
  printf("        Height: %d\n",height);
  printf("      SMS Size: %d\n",full_sms_size);

  if (mcc!=-1 && mnc!=-1)
  {
    printf("       MCC MNC: %d %d\n",mcc,mnc);
  }

  fp=fopen(filename,"r");
  if (fp==0)
  {
    printf("Could not open file for reading: %s\n",filename);
    exit(0);
  }

  push(0x30,8);   /* Identifier for version */

  if (mcc!=-1 && mnc!=-1)
  {
    t=mcc%10;
    k=(mcc/10)%10;
    r=(mcc/100)%10;
    push((k<<4)+r,8);   /* MCC Mobile Country Code */
    push(0xF0+t,8);     /* MCC Mobile Country Code */
    t=mnc%10;
    k=(mnc/10)%10;
    push((t<<4)+k,8);   /* MNC Mobile Network Code */
    push(0x0A,8);       /* Line feed */
  }

  push(0x00,8);   /* Info Field? */
  push(width,8);   /* height and width DUH */
  push(height,8);
  push(0x01,8);    /* picture depth */

  k=stackptr;

  x=0; y=0;
  while ((ch=getc(fp))!=EOF)
  {
    if (ch=='\n' || ch=='\r')
    {
      if ((lastch=='\r' || lastch=='\n') && ch!=lastch) continue;
      for (t=x; t<width; t++) push(0,1);
      x=0; y++;
      continue;
    }

    if (ch==' ') 
    { push(0,1); }
      else
    { push(1,1); }

    x++;

    if (x>=width)
    {
      while ((ch=getc(fp))!=EOF)
      { if (ch=='\n' || ch=='\r') break; }
      y++;
      if (y>=height) break;
      x=0;
    }

    lastch=ch;
  }

  if (x!=0)
  { for (t=x; t<width; t++) push(0,1); }

#ifdef DEBUG
printf("y=%d   height=%d\n",y,height);
#endif

  for (r=y; r<height; r++)
  {
#ifdef DEBUG
printf("t=%d\n",t);
#endif
    for (t=0; t<width; t++) push(0,1);
  }

  fclose(fp);

#ifdef DEBUG
  for (x=k; x<stackptr; x++)
  {
    for (y=7; y>=0; y--)
    {
      printf("%d",(((ring_stack[x])>>y)&1));
    }
    if ((x%9)==4) printf("\n");
  }
#endif

  stackptr++;

  if (mcc!=-1 && mnc!=-1)
  { print_codes(full_sms_size,"1582",headers); }
    else
  { print_codes(full_sms_size,"1583",headers); }

  return (0);
}



